import {__rest}from'tslib';import {useToast,Center,Spinner,Box,Divider,Button,Spacer,Grid,GridItem,Image,Flex,VStack,HStack,Avatar}from'@chakra-ui/react';import React__default from'react';import {BsStarFill,BsStar,BsHeart,BsHeartFill}from'react-icons/bs';import {useQuery,useMutation}from'react-query';import {useParams,useHistory,useLocation}from'react-router-dom';import {fetchPropertyById,toggleLike,fetchReviewsForProperty}from'../API.js';import PickRangeDay from'../components/NavComponents/PickRangeDay.js';import FloatingForm from'../components/FloatingForm.js';import MyRoomBadge,{defaultRoomBadges}from'../components/SingleRoomComponents/MyRoomBadge.js';import {AuthContext}from'../Contexts/AuthContext.js';const SingleRoom = ({ initRoom, children }) => {
    var _a, _b;
    const auth = React__default.useContext(AuthContext);
    const [room, setRoom] = React__default.useState();
    const [bookInfo, setBookInfo] = React__default.useState({ guest: 0, children: 0 });
    const [didLike, setDidLike] = React__default.useState(false);
    const { slug } = useParams();
    const toast = useToast();
    const history = useHistory();
    const { data, isError, error, isLoading } = useQuery(["property", slug], () => {
        return fetchPropertyById(slug);
    }, {
        // staleTime: 1000 * 60 * 3,
        retry: 2,
        onError: (error) => {
            console.log(error);
        },
        onSuccess: (rs) => {
            if (rs.data.liked)
                setDidLike(rs.data.liked);
            setRoom(Object.assign(Object.assign({}, rs.data), { roomBadges: badges }));
            setBookInfo(bi => (Object.assign(Object.assign({}, bi), { roomId: rs.data.id })));
        },
        onSettled: () => {
        }
    });
    const mutateLike = useMutation(toggleLike, {
        onSuccess: (res) => {
            setDidLike(res.data.liked);
            toast({
                description: res.data.liked ? "Saved room" : "Removed from wishlist",
                status: "info",
                duration: 1000
            });
        },
        onError: (error) => console.log(error)
    });
    const updateDate = (from, to) => {
        setBookInfo(s => (Object.assign(Object.assign({}, s), { bookFromDate: from, bookToDate: to })));
    };
    const updatePeople = (adult, children) => {
        setBookInfo((s) => (Object.assign(Object.assign({}, s), { guest: adult, children: children })));
    };
    const handleLike = () => {
        if (!room)
            return;
        if (!auth.user) {
            toast({
                description: "Login is required",
                status: "info",
                duration: 1000
            });
            return;
        }
        mutateLike.mutate({ roomId: room.id, token: auth.user.token });
    };
    let location = useLocation();
    const handleEditProp = () => {
        history.push(Object.assign(Object.assign({}, location), { pathname: `/host/publish`, search: `?id=${room === null || room === void 0 ? void 0 : room.id}` }));
    };
    const handleLocationOnClick = (location) => {
        history.push({
            pathname: "/rooms",
            state: {
                search: {
                    city: location,
                }
            }
        });
    };
    if (isLoading)
        return (React__default.createElement(Center, null,
            React__default.createElement(Spinner, null)));
    if (room)
        return (React__default.createElement(Box, null,
            React__default.createElement(Divider, { my: "5" }),
            React__default.createElement(Box, { as: "h2", fontSize: "3xl", fontWeight: "semibold" }, room.name),
            React__default.createElement(Box, { d: "flex", mt: "1", flexDir: { base: "column", sm: "row" }, justifyItems: "baseline" },
                React__default.createElement(Box, { d: "flex", alignItems: "start" },
                    React__default.createElement(Box, { d: "flex", flexDir: { base: "column", sm: "row" } },
                        React__default.createElement(Box, { d: "flex", flexDir: { base: "row" } }, Array(5).fill("").map((_, i) => {
                            return (i < Math.round(room.totalStar / room.totalReview) ? React__default.createElement(BsStarFill, { key: i, colorRendering: "teal.400" }) : React__default.createElement(BsStar, { key: i }));
                        })),
                        React__default.createElement(Box, { as: "span", ml: "2", color: "gray.500" },
                            room.totalReview,
                            " reviews")),
                    React__default.createElement(Box, { mx: "4" }, "\u2022"),
                    React__default.createElement(Button, { variant: "link", onClick: () => handleLocationOnClick(room.location) }, room.location)),
                React__default.createElement(Spacer, null),
                room.ownerInfo.userId === ((_a = auth.user) === null || _a === void 0 ? void 0 : _a.userId) &&
                    React__default.createElement(Button, { onClick: () => { handleEditProp(); } }, "Edit"),
                React__default.createElement(Button, { alignSelf: "start", variant: "ghost", onClick: () => handleLike(), leftIcon: (!didLike || !auth.user) ? React__default.createElement(BsHeart, null) : React__default.createElement(BsHeartFill, { color: "red" }) }, "Like")),
            React__default.createElement(Box, { borderRadius: "lg", overflow: "hidden", mt: "4" },
                React__default.createElement(Grid, { gap: "2", h: "40%", maxH: "450px", objectFit: "cover", templateRows: "repeat(2, 1fr)", templateColumns: "repeat(4, 1fr)" }, room.images.slice(0, 5).map((image, i) => {
                    return (React__default.createElement(GridItem, { key: i, colSpan: i === 0 ? 2 : 1, rowSpan: i === 0 ? 2 : 1, overflow: "hidden" },
                        React__default.createElement(Image, { src: image.url, h: "auto", height: "100%", w: "100%", objectFit: "cover", loading: "lazy" })));
                }))),
            React__default.createElement(Box, { mt: "4", d: ["flex", "flex", "flex", "block"], flexDir: "column-reverse" },
                React__default.createElement(Box, { w: ["100%", "100%", "100%", "35%"], boxShadow: "2xl", mt: { base: "4", lg: "0" }, top: "30%", float: { lg: "right" }, position: { lg: "sticky" }, borderRadius: "lg", display: "inline-flex", flexDir: "column", zIndex: 1, borderWidth: "thin", p: "4", alignContent: "center", justifyContent: "center" },
                    React__default.createElement(FloatingForm, { room: room, bookInfo: bookInfo, updateDate: updateDate, updatePeople: updatePeople })),
                React__default.createElement(Box, { w: ["100%", "100%", "100%", "60%"] },
                    React__default.createElement(Flex, { alignItems: "center" },
                        React__default.createElement(VStack, { alignItems: "start" },
                            React__default.createElement(Box, { as: "h1", fontSize: "2xl", fontWeight: "semibold" }, "Owner: " + room.ownerInfo.name),
                            React__default.createElement(HStack, null, room.services && room.services.map((s, i) => {
                                return (React__default.createElement(Box, { key: i, color: "gray.500", fontWeight: "semibold", letterSpacing: "wide", fontSize: "xs", textTransform: "uppercase", ml: "2", isTruncated: true },
                                    s.serviceName,
                                    " ",
                                    room.services[room.services.length - 1] !== s && React__default.createElement(React__default.Fragment, null, "\u2022"),
                                    " "));
                            }))),
                        React__default.createElement(Spacer, null),
                        React__default.createElement(Avatar, { name: room.ownerInfo.name, src: room.ownerInfo.profileImageUrl, cursor: "pointer", onClick: () => alert("go to user's page") })),
                    React__default.createElement(Divider, { my: "3" }), (_b = room.roomBadges) === null || _b === void 0 ? void 0 :
                    _b.map((b, i) => {
                        return React__default.createElement(MyRoomBadge, { id: b.id, key: i });
                    }),
                    React__default.createElement(Divider, { my: "3" }),
                    React__default.createElement(Box, { as: "h5", fontWeight: "semibold", fontSize: "2xl" }, "More about room"),
                    React__default.createElement(Box, { as: "p" }, room.introduction),
                    React__default.createElement(Divider, { my: "3" }),
                    React__default.createElement(Box, { w: "100%", display: { base: "none", sm: "block" } },
                        React__default.createElement(PickRangeDay, { schedules: { reservedDates: room.reservedDates, dayOff: room.daysOff }, updateDate: updateDate })))),
            React__default.createElement(Divider, { my: "5" }),
            React__default.createElement(ReviewDisplay, { propId: room.id })));
    return React__default.createElement(React__default.Fragment, null);
};
const ReviewDisplay = (props) => {
    var _a, _b, _c;
    const { propId } = props; __rest(props, ["propId"]);
    const fetchReviews = useQuery(["reviews", propId], () => fetchReviewsForProperty(propId), {
        retry: 2,
        onSuccess: (data) => {
        },
    });
    const reviews = ((_a = fetchReviews.data) === null || _a === void 0 ? void 0 : _a.data) ? fetchReviews.data.data : [];
    let totalStar = 0;
    reviews.forEach(r => totalStar += r.starCount);
    return (React__default.createElement(Box, null,
        React__default.createElement(Box, { d: "flex", gridGap: "2", alignItems: "baseline", fontWeight: "semibold", fontSize: "2xl", mb: "5" },
            React__default.createElement(BsStarFill, null),
            React__default.createElement(Box, { as: "h2" },
                " ",
                reviews.length != 0 ? (totalStar / reviews.length).toPrecision(2) : 0,
                " (",
                reviews.length,
                " reviews)")),
        ((_b = fetchReviews.data) === null || _b === void 0 ? void 0 : _b.data.length) === 0
            ? React__default.createElement(Box, { fontWeight: "light" }, "Looks like this property does not have any reviews")
            :
                React__default.createElement(Box, { d: 'flex', flexWrap: "wrap", gridGap: "5" }, (_c = fetchReviews.data) === null || _c === void 0 ? void 0 :
                    _c.data.map(r => React__default.createElement(ReviewComment, { review: r, key: r.reviewId })),
                    React__default.createElement(ReviewComment, { review: testReview }),
                    React__default.createElement(ReviewComment, { review: testReview }),
                    React__default.createElement(ReviewComment, { review: testReview }))));
};
const testReview = {
    user: {
        name: "Test user name",
        userId: "123",
        profileImageUrl: ""
    },
    comment: "Lorem ipsum dolor sit amet consectetur adipisicing elit. Id, repellat. Harum, facilis corrupti eligendi laborum minus nihil et a mollitia!",
    propertyId: "1",
    reviewId: "123123",
    starCount: 4,
    timeCreated: "20202020",
    timeUpdated: "20202020"
};
const ReviewComment = (props) => {
    var _a;
    const { review } = props, boxProps = __rest(props, ["review"]);
    return (React__default.createElement(Box, Object.assign({}, boxProps, { flex: "1 1 25em" }),
        React__default.createElement(Box, { d: "flex", flexDir: "row", gridGap: "2" },
            React__default.createElement(Avatar, { name: (_a = review.user) === null || _a === void 0 ? void 0 : _a.name, src: review.user.profileImageUrl }),
            React__default.createElement(Box, { d: "flex", flexDir: "column" },
                React__default.createElement(Box, { as: "h4", fontWeight: "bold" }, review.user.name),
                React__default.createElement(Box, { as: "h4", fontWeight: "light" }, review.timeUpdated))),
        React__default.createElement(Box, { as: "h4" }, review.comment)));
};
const badges = defaultRoomBadges;export default SingleRoom;//# sourceMappingURL=SingleRoom.js.map
