import {__rest}from'tslib';import React__default from'react';import {useDisclosure,useColorModeValue,Box,Flex,HStack,Center,Heading,Spacer,Button,Modal,ModalOverlay,ModalContent,ModalHeader,ModalCloseButton,ModalBody,Menu,MenuButton,MenuList,MenuItem,MenuDivider}from'@chakra-ui/react';import {ColorModeSwitcher}from'../../ColorModeSwitcher.js';import {Logo}from'../../Logo.js';import {useLocation,Link}from'react-router-dom';import {AuthContext}from'../../Contexts/AuthContext.js';import {BsChevronDown,BsBookmark,BsCalendar,BsBell,BsLock,BsHouse,BsPerson,BsBoxArrowDown}from'react-icons/bs';import LoginForm from'../LoginForm.js';const Navbar = (_a) => {
    var _b;
    var props = __rest(_a, []);
    const auth = React__default.useContext(AuthContext);
    const loginFormModal = useDisclosure();
    const initRef = React__default.useRef(null);
    const [isRegistering, setIsRegistering] = React__default.useState(false);
    // check if we are at homepage, then do a bit of theme modification
    useLocation();
    useColorModeValue("gray.800", "gray.800");
    useColorModeValue("white", "white");
    const becomehostColor = useColorModeValue("cyan.200", "blue.400");
    return (React__default.createElement(Box, Object.assign({ marginBottom: ["5%"] }, props),
        React__default.createElement(Flex, { justifyContent: "center", alignItems: "center" },
            React__default.createElement(Link, { to: "/" },
                React__default.createElement(HStack, { spacing: 4 },
                    React__default.createElement(Center, null,
                        React__default.createElement(Logo, null)),
                    React__default.createElement(Heading, { size: "md", display: { base: "none", sm: "block" } }, "Nice homestays"))),
            React__default.createElement(Spacer, null),
            React__default.createElement(HStack, { spacing: 4 },
                React__default.createElement(ColorModeSwitcher, null),
                auth.user === undefined ?
                    React__default.createElement(React__default.Fragment, null,
                        React__default.createElement(Button, { variant: "ghost", onClick: () => { loginFormModal.onOpen(); setIsRegistering(false); } }, "Login"),
                        React__default.createElement(Modal, { isOpen: loginFormModal.isOpen, onClose: loginFormModal.onClose, size: "xl", motionPreset: "slideInBottom", isCentered: true, initialFocusRef: initRef },
                            React__default.createElement(ModalOverlay, null),
                            React__default.createElement(ModalContent, null,
                                React__default.createElement(ModalHeader, null, isRegistering ? "Sign up new account" : "Login"),
                                React__default.createElement(ModalCloseButton, null),
                                React__default.createElement(ModalBody, { pb: "2" },
                                    React__default.createElement(LoginForm, { initRef: initRef, isRegistering: isRegistering })))),
                        React__default.createElement(Button, { variant: "ghost", onClick: () => { loginFormModal.onOpen(); setIsRegistering(true); } }, "Register")) :
                    React__default.createElement(React__default.Fragment, null,
                        React__default.createElement(Menu, null,
                            React__default.createElement(MenuButton, { as: Button, variant: "ghost", rightIcon: React__default.createElement(BsChevronDown, null) }, auth.user.name),
                            React__default.createElement(MenuList, null,
                                React__default.createElement(MenuItem, { as: Link, to: "/profile?view=likes" },
                                    React__default.createElement(Box, { mr: "3" },
                                        React__default.createElement(BsBookmark, null)),
                                    "Saved rooms"),
                                React__default.createElement(MenuItem, { as: Link, to: "/profile?view=reservations" },
                                    React__default.createElement(Box, { mr: "3" },
                                        React__default.createElement(BsCalendar, null)),
                                    "Your Reservations"),
                                React__default.createElement(MenuItem, { as: Link, to: "/profile?view=notifications" },
                                    React__default.createElement(Box, { mr: "3" },
                                        React__default.createElement(BsBell, null)),
                                    "Notifications"),
                                React__default.createElement(MenuDivider, null),
                                ((_b = auth.user.roles) === null || _b === void 0 ? void 0 : _b.includes("Owner")) ?
                                    React__default.createElement(React__default.Fragment, null,
                                        React__default.createElement(MenuItem, { as: Link, to: "/host/publish" },
                                            React__default.createElement(Box, { mr: "3" },
                                                React__default.createElement(BsLock, null)),
                                            "Host your property"),
                                        React__default.createElement(MenuItem, { as: Link, to: "/host/properties" },
                                            React__default.createElement(Box, { mr: "3" },
                                                React__default.createElement(BsHouse, null)),
                                            "Your properties"))
                                    :
                                        React__default.createElement(MenuItem, { bg: becomehostColor, as: Link, to: "/user/register-host" },
                                            React__default.createElement(Box, { mr: "3" },
                                                React__default.createElement(BsLock, null)),
                                            "Become a host"),
                                React__default.createElement(MenuItem, { as: Link, to: "/" },
                                    React__default.createElement(Box, { mr: "3" },
                                        React__default.createElement(BsPerson, null)),
                                    "Account"),
                                React__default.createElement(MenuDivider, null),
                                React__default.createElement(MenuItem, { onClick: () => auth.logoutAsync() },
                                    React__default.createElement(Box, { mr: "3" },
                                        React__default.createElement(BsBoxArrowDown, null)),
                                    "Log Out"))))))));
};export default Navbar;//# sourceMappingURL=Navbar.js.map
