import { IMenuPosition } from '@common-stack/client-react';
import { Main } from './main';
import { getFilteredMenus, getFilteredRoutes } from '../utils';

export const hostelPageStore = [
    {
        path: '/',
        key: 'hostel',
        exact: true,
        name: 'Hostel',
        component: Main,
        position: IMenuPosition.MIDDLE,
    },
];

const selectedRoutesAndMenus = ['hostel'];

// get menus
const filteredMenus = getFilteredMenus(hostelPageStore, selectedRoutesAndMenus);

// get routes
const filteredRoutes = getFilteredRoutes(hostelPageStore, selectedRoutesAndMenus);

export { filteredMenus, filteredRoutes };
